<?php
/**
 * 短信发送API
 */
namespace kwy\sms;
class SmsMessageApi{
    ####  下面是客无忧的一些参数，仅供参考 start  ###
    //客无忧账户信息
    private $kwy_param = [
        'account' => '98a9fe',
        'password' => 'hcx0tkerlp',
        'tag' => '【客无忧】'
    ];

    //客无忧营销账户信息
    private $kwy_marketing_param = [
        'account' => '98aa97',
        'password' => 'gtq29d16hy',
        'tag' => '【客无忧】'
    ];
    ####  下面是客无忧的一些参数，仅供参考 end  ###


    private $account = '';
    private $password = '';
    private $tag = '';

    /**
     * 初始化参数
     * @param $account
     * @param $password
     * @param $tag
     */
    public function initParam($account,$password,$tag){
        $this->account = $account;
        $this->password = $password;
        $this->tag = $tag;
    }

    /**
     * 日志
     * @var array
     */
    private $logData = [];

    /**
	 * 发送短信
	 * @param String $tel 电话号码
	 * @param String $content  短信内容
	 * @return boolean  true:发送成功 ; false: 发送失败
	 */
    public function sendMessage($tel,$content){
        $target = "http://api.chanzor.com/send";
        $data = [
            'account' => $this->account,
            'password' => $this->password,
            'mobile' => $tel,
            'content' => ($content.$this->tag)
        ];

        $gets = $this->postCurl($target,$data);

        $this->setLog('发送短信',$data,$gets);

        if(empty($gets)){
            return false;
        }
        $data = json_decode($gets,true);
        if(empty($data)){
            return false;
        }
        return $data;
    }

    /**
     * @param $taskId
     * @param string $type
     * @return bool|mixed
     * @example
     * array(3) {
    ["status"] => int(0)
    ["desc"] => string(6) "成功"
    ["drList"] => array(1) {
    [0] => array(6) {
    ["mobile"] => string(11) "18170239278"
    ["taskId"] => string(18) "180713140107421615"
    ["receiveTime"] => string(19) "2018-07-13 14:01:58"
    ["extno"] => string(13) "1069212588391"
    ["errorCode"] => string(7) "DELIVRD"
    ["status"] => int(10)
    }
    }
    }
     * errorCode是描述:成功 DELIVERD  或 失败描述
     * status是发送状态:10 成功接收 20 失败
     */
    public function queryMessage($taskId,$type='kwy'){
        $target = "http://api.chanzor.com/dr";
        //替换成自己的测试账号
        if($type == 'kwy'){
            $params = $this->kwy_param;
        }else{
            $params = $this->kwy_marketing_param;
        };

        //替换成自己的账号
        $account = $params['account'];
        $password = $params['password'];

        $url = $target.'?'."userid=&account=$account&password=$password&taskId=$taskId";
        $gets = $this->getCurl($url);

        if(empty($gets)){
            return false;
        }
        $data = json_decode($gets,true);
        if(empty($data)){
            return false;
        }
        return $data;
    }

    /**
     * 设置日志
     * @param $type
     * @param $data
     * @param $return_data
     */
    private function setLog($type,$data,$return_data){
        if(is_array($data)){
            $data = json_encode($data,320);
        }
        if(is_array($return_data)){
            $return_data = json_encode($return_data,320);
        }
        $log = [
            'type' => $type,
            'post_param' => $data,
            'return_data' => $return_data,
            'create_time' => date("Y-m-d H:i:s")
        ];
        $this->logData = $log;
    }

    /**
     * 获取请求/返回数日志
     * @return false|string
     */
    public function getLogData(){
        return json_encode($this->logData);
    }

    /**
     * post请求
     * @param $url
     * @param array $data
     * @return bool|mixed
     */
    private function postCurl($url,$data=[]){
        $jsonStr = http_build_query($data);
        $ch = curl_init();
        $header[] = "Accept-Charset: utf-8";
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        curl_setopt($ch, CURLOPT_IPRESOLVE, CURL_IPRESOLVE_V4 );//强制ipv4解析
        curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (compatible; MSIE 5.01; Windows NT 5.0)');
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($ch, CURLOPT_AUTOREFERER, 1);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Expect:'));

        curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonStr);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $tmpInfo = curl_exec($ch);
        if (curl_errno($ch)) {
            curl_close($ch);
            return false;
        }else{
            curl_close($ch);
            return $tmpInfo;
        }
    }

    /**
     * get请求
     * @param $url
     * @return mixed
     */
    private function getCurl($url){
        $ch = curl_init($url) ;
        curl_setopt($ch, CURLOPT_FRESH_CONNECT,  true);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);  //协议头 https，curl 默认开启证书验证，所以应关闭

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true) ; // 获取数据返回
        curl_setopt($ch, CURLOPT_IPRESOLVE, CURL_IPRESOLVE_V4 );//强制ipv4解析
        curl_setopt($ch, CURLOPT_BINARYTRANSFER, true) ; // 在启用 CURLOPT_RETURNTRANSFER 时候将获取数据返回
        $output = curl_exec($ch) ;
        curl_close($ch);
        return $output;
    }
}